ado/ado/examples/portfolio/urls.py
from django.conf.urls import url
from ado.examples.portfolio import views
from ado import menus

urlpatterns = [
    url(r'^$', views.index, name='portfolio-collection-index'),
    url(r'^(?P<slug>[\w-]+)/$', views.view, name='portfolio-collection-view'),
]

menus.register_url('Portfolio', name='portfolio-collection-index')

ado/ado/urls.py
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.views.generic import TemplateView
from django.conf import settings
from django.contrib import admin

urlpatterns = [
    url(r'^$', TemplateView.as_view(template_name='index.html'), name='index'),
    url(r'^media/', include('ado.media.urls')),

    # App examples
    url(r'^pages/', include('ado.examples.pages.urls')),
    url(r'^portfolio/', include('ado.examples.portfolio.urls')),
    url(r'^artists/', include('ado.examples.artists.urls')),
    url(r'^exhibitions/', include('ado.examples.exhibitions.urls')),
    url(r'^blog/', include('ado.examples.blog.urls')),

    # Admin
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^customadmin/', include('ado.customadmin.urls')),
    url(r'^admin/media/', include('ado.media.admin.urls')),
    url(r'^admin/', include(admin.site.urls)),
]

# MEDIA For Development Server
urlpatterns += static(settings.MEDIA_URL,
                      document_root=settings.MEDIA_ROOT,
                      show_indexes=True)

riverstreet/urls.py
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.conf import settings
from django.contrib import admin
from riverstreet.core.views import Redirect
from riverstreet.blog.views import BlogRedirectView
from riverstreet.core import views


urlpatterns = [
    url(r'^$', views.index, name='home'),
    url(r'^login$', views.index, name='login'),
    url(r'^media', views.index),
    url(r'^promotion/', include('riverstreet.promotion.urls', namespace='promotion')),
    url(r'^work/', include('riverstreet.work.urls', namespace='work')),
    url(r'^p/', include('riverstreet.pages.urls', namespace='pages')),
    url(r'^people/', include('riverstreet.people.urls', namespace='people')),
    url(r'^news/', include('riverstreet.blog.urls', namespace='blog')),

    url(r'^clients/(?P<id>\d+)/?', views.index, name='clients-detail'),
    url(r'^clients/(?P<username>[^/]+)/?', views.index, name='clients-detail'),
    url(r'^clients/?', views.index, name='clients'),

    url(r'^vimeo/album/(?P<id>[^/]+)/?$', views.index, name='vimeo-album'),

    url(r'^typography/?$', views.index, name='typography'),

    # Admin:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^customadmin/', include('ado.customadmin.urls')),
    url(r'^admin/media/', include('ado.media.admin.urls')),
    url(r'^admin/', include(admin.site.urls)),
]

# Graphql urls
urlpatterns += [
    url(r'^graphql', views.graphql_view),
]

# MEDIA For Development Server
urlpatterns += static(settings.MEDIA_URL,
                      document_root=settings.MEDIA_ROOT,
                      show_indexes=True)

# Legay site redirects
urlpatterns += [
    # categories & projects
    url(r'^collections/cat/(?P<slug>[^/]+)/?',
        Redirect.as_view(pattern_name='work:category')),
    url(r'^collections/(?P<slug>[^/]+)/?',
        Redirect.as_view(pattern_name='work:project-detail')),
    url(r'^collections/?', Redirect.as_view(url='/work')),

    # pages
    url(r'^pages/contact/?',
        Redirect.as_view(url='/p/about-us')),
    url(r'^pages/(?P<slug>[^/]+)/?',
        Redirect.as_view(pattern_name='pages:detail')),

    # blog
    url(r'^blog', BlogRedirectView.as_view()),

    # clientpages
    url(r'^clientpages/(?P<slug>[^/]+)/?',
        Redirect.as_view(pattern_name='promotion:reel-detail')),

    # clientsections (must be last!)
    url(r'^(?P<slug>(tracypion_director|selected-work-alternative-content|generation-create|editorial-work|showreel-database|advocacy|tracypion))/.*', # noqa
        Redirect.as_view(pattern_name='promotion:minisite')),
]

ado/ado/examples/portfolio/models.py
from __future__ import unicode_literals

from django.db import models
from django.utils.encoding import python_2_unicode_compatible

from positions import PositionField
from ado.media.fields.related import RelatedImagesField, RelatedFilesField
from autoslug import AutoSlugField


@python_2_unicode_compatible
class CollectionCategory(models.Model):
    name = models.CharField(max_length=200)
    slug = AutoSlugField(
        populate_from='name',
        max_length=200,
        unique=True,
        editable=False,
        help_text='Unique text identifier used in urls.')
    published = models.BooleanField(
        default=True,
        help_text='Whether to publish on the site.')
    sort = PositionField(
        'Position',
        help_text='Lower numbers will appear first on site.')

    class Meta:
        ordering = ('sort', 'id')
        verbose_name = 'Category'
        verbose_name_plural = 'Categories'

    def __str__(self):
        return self.name


@python_2_unicode_compatible
class Collection(models.Model):
    """
    A Collection of images and/or files
    """
    title = models.CharField(max_length=200)
    slug = AutoSlugField(
        populate_from='title',
        max_length=200,
        unique=True,
        editable=False,
        help_text='Unique text identifier used in urls.')
    date = models.DateField(blank=True, null=True)
    published = models.BooleanField(
        default=True,
        help_text='Whether to publish on the site.')
    text = models.TextField(blank=True)
    created = models.DateTimeField(auto_now_add=True)
    modified = models.DateTimeField(auto_now=True)
    sort = PositionField(
        'Position',
        help_text='Lower numbers appear first on site.')
    categories = models.ManyToManyField('CollectionCategory', blank=True)
    image = models.ForeignKey('media.Image', null=True, blank=True)

    images = RelatedImagesField()
    files = RelatedFilesField()

    class Meta:
        ordering = ('-date', 'sort', 'id')

    def __str__(self):
        return u'%s' % self.title

    def has_media(self):
        if self.images.count() or self.files.count():
            return True
        return False

    @models.permalink
    def get_absolute_url(self):
        return 'portfolio-collection-view', [self.slug]

ado/ado/examples/portfolio/views.py
from __future__ import unicode_literals

from django.views.generic import ListView, DetailView
from ado.examples.portfolio.models import Collection, CollectionCategory


class CollectionListView(ListView):
    queryset = CollectionCategory.objects.filter(published=True)
    template_name = 'portfolio/collection/index.html'
    context_object_name = 'collection_categories'

    def get_queryset(self):
        qs = super(CollectionListView, self).get_queryset()

        if 'year' in self.request.GET:
            try:
                year = int(self.request.GET['year'])
                qs = qs.filter(collections__date__year=year)
            except ValueError:
                pass

        return qs

    def get_context_data(self, **kwargs):
        context = super(CollectionListView, self).get_context_data(**kwargs)
        year = None
        if 'year' in self.request.GET:
            year = self.request.GET['year']
            context.update({
                'year': year,
            })
        return context


index = CollectionListView.as_view()


class CollectionDetailView(DetailView):
    queryset = Collection.objects.filter(published=True)
    template_name = 'portfolio/collection/view.html'

    def get_context_data(self, **kwargs):
        context = super(CollectionDetailView, self).get_context_data(**kwargs)
        collection = context['object']
        images = collection.images.all()
        context.update({
            'collections': self.get_queryset(),
            'images': images,
        })
        return context


view = CollectionDetailView.as_view()

ado/ado/examples/portfolio/templates/portfolio/collection/index.html
{% extends "base.html" %}
{% load thumbnail collections %}

{% block extrahead %}
<script type="text/javascript">
$(function() {
    var $menu_link = $('#main-menu a[href={% url 'portfolio-collection-index' %}]').addClass('active');
    {% if year %}
    var $year_link = $('.dates-menu a[rel={{year}}]').addClass('active');
    {% endif %}
});
</script>
{% endblock %}

{% block content %}
<ul class="collection-index">
{% for category in collection_categories  %}
<li>
    <h1 class="title">{{category}}</h1>
    <ul>
{% for collection in category.collection_set.all %}
        <li class="collection">
        <table>
            <tr>
            <td class="info">
                <h3 class="title"><a href="{% url 'portfolio-collection-view' collection.slug %}">{{collection}}</a></h3>
            </td>
            <td class="images">
                {% for image in collection.images.all|slice:"0:4" %}
                {% thumbnail image.filename "180x160" as thumb %}
                <a href="{% url 'portfolio-collection-view' collection.slug %}#{{forloop.counter0}}"><img src="{{thumb.url}}" alt="thumbnail" /></a>
                {% endthumbnail %}
                {% endfor %}
            </td>
            </tr>
        </table>
    </li>
    {% endfor %}
    </ul>
</li>
{% endfor %}
</ul>
{% endblock %}

ado/ado/examples/portfolio/templates/portfolio/collection/view.html
{% extends "base.html" %}
{% load static thumbnail collections %}

{% block extrahead %}
<script type="text/javascript" src="{% static 'js/imageframe.js' %}"></script>

<script type="text/javascript">
$(function() {
    var $menu_link = $('#main-menu a:contains(Portfolio)').addClass('active');
    $('#main-menu a[href={{ collection.get_absolute_url }}]').addClass('active');

    {% if collection.images.count %}{% spaceless %} 
    var images = [
        {% for image in collection.images.all %}
        {
            img: '{{image.filename.url}}',
            caption: '{{image.caption|urlencode}}',
            audiofile: {% if image.audiofile %}'{{image.audiofile.url}}'{% else %}null{% endif %}
        }{% if not forloop.last %},{% endif %}
        {% endfor %}
    ];
    {% endspaceless %}{% endif %}

    // Image navigation
    var hash = window.location.hash;
    i = hash ? parseInt(hash.replace('#', '')) : 0;
    if (isNaN(i)) i = 0;
    $('.main-image').ImageFrame(images, {
        fullscreen: false,
        max_width: 'container',
        max_height: 'container',
        startImage: i,
        prevButtonHTML: '<a>Previous Image</a> &nbsp;',
        nextButtonHTML: '<a>Next Image</a> ',
        show_image_count: false,
        imageControlsContainer: $('<div class="image-controls"></div>').prependTo('.image-info')
    });
});
</script>
{% endblock %}


{% block content %}
{% with collection.images.all as images %}
<div class="collection">
    <table>
        <tr>
            <td class="image-info">
                <a href="{% url 'portfolio-collection-index' %}">Back to thumbnails</a>
                <div class="image-caption">{% if images %}{{images.0.caption|safe}}{% endif %}</div>
            </td>
            {% thumbnail images.0.filename "580x500" as thumb %}
            <td class="main-image">{% if images %}<a><img src="{{thumb.url}}" alt="image" /></a>{% endif %}</td>
            {% endthumbnail %}
        </tr>
    </table>

    {% if collection.files.count %}
    <ul class="file-list">
    {% for file in collection.files.all %}
        <li><a href="{{file.filename.url}}" target="_blank">{{file.title|default:file}}</a></li>
    {% endfor %}
    </ul>
    {% endif %}
</div>
{% endwith %}
{% endblock %}